diff --git a/src/preamble.js b/src/preamble.js
index 517bcfa5610..8a1de75cb81 100644
--- a/src/preamble.js
+++ b/src/preamble.js
@@ -599,7 +599,7 @@ function abort(what) {
   err(what);
 
   ABORT = true;
-  EXITSTATUS = 1;
+  EXITSTATUS = 134; // 128 + 6(SIGABRT)
 
 #if ASSERTIONS == 0
   what = 'abort(' + what + '). Build with -s ASSERTIONS=1 for more info.';
@@ -1067,6 +1067,10 @@ function createWasm() {
         var search = location.search;
         if (search.indexOf('_rwasm=0') < 0) {
           location.href += (search ? search + '&' : '?') + '_rwasm=0';
+          // Return here to avoid calling abort() below.  The application
+          // still has a chance to start sucessfully do we don't want to
+          // trigger onAbort on onExit handlers.
+          return;
         }
 #if ENVIRONMENT_MAY_BE_NODE || ENVIRONMENT_MAY_BE_SHELL
       }
diff --git a/tests/browser/test_assert_failure.c b/tests/browser/test_assert_failure.c
new file mode 100644
index 00000000000..9c1a4d35090
--- /dev/null
+++ b/tests/browser/test_assert_failure.c
@@ -0,0 +1,7 @@
+#include <assert.h>
+#include <stdbool.h>
+
+int main() {
+  assert(false && "this is a test");
+  return 0;
+}
diff --git a/tests/browser_reporting.js b/tests/browser_reporting.js
index dd4d9727805..79c1231b9d2 100644
--- a/tests/browser_reporting.js
+++ b/tests/browser_reporting.js
@@ -43,4 +43,11 @@ if (hasModule) {
   Module['onExit'] = function(status) {
     maybeReportResultToServer('exit:' + status);
   }
+
+  // Ideally onExit would be enought to catch this but we decided
+  // against that for codesize reasons:
+  // See: https://github.com/emscripten-core/emscripten/pull/13631
+  Module['onAbort'] = function(reason) {
+    maybeReportResultToServer('abort:' + reason);
+  }
 }
diff --git a/tests/runner.py b/tests/runner.py
index 23d1f1ac223..dd15c8ed96d 100755
--- a/tests/runner.py
+++ b/tests/runner.py
@@ -1367,8 +1367,9 @@ def run_browser(self, html_file, message, expectedResult=None, timeout=None, ext
           self.skipTest(unquote(output[len('/report_result?skipped:'):]).strip())
         else:
           # verify the result, and try again if we should do so
+          output = unquote(output)
           try:
-            self.assertIdenticalUrlEncoded(expectedResult, output)
+            self.assertContained(expectedResult, output)
           except Exception as e:
             if extra_tries > 0:
               print('[test error (see below), automatically retrying]')
diff --git a/tests/test_browser.py b/tests/test_browser.py
index eac0cc605c1..297110cfbd6 100644
--- a/tests/test_browser.py
+++ b/tests/test_browser.py
@@ -3323,7 +3323,7 @@ def test_modularize(self):
   def test_modularize_network_error(self):
     test_c_path = path_from_root('tests', 'browser_test_hello_world.c')
     browser_reporting_js_path = path_from_root('tests', 'browser_reporting.js')
-    self.compile_btest([test_c_path, '-s', 'MODULARIZE', '-s', 'EXPORT_NAME="createModule"', '--extern-pre-js', browser_reporting_js_path])
+    self.compile_btest([test_c_path, '-s', 'MODULARIZE', '-s', 'EXPORT_NAME="createModule"', '--extern-pre-js', browser_reporting_js_path], reporting=Reporting.NONE)
     create_test_file('a.html', '''
       <script src="a.out.js"></script>
       <script>
@@ -3343,7 +3343,7 @@ def test_modularize_network_error(self):
   def test_modularize_init_error(self):
     test_cpp_path = path_from_root('tests', 'browser', 'test_modularize_init_error.cpp')
     browser_reporting_js_path = path_from_root('tests', 'browser_reporting.js')
-    self.compile_btest([test_cpp_path, '-s', 'MODULARIZE', '-s', 'EXPORT_NAME="createModule"', '--extern-pre-js', browser_reporting_js_path])
+    self.compile_btest([test_cpp_path, '-s', 'MODULARIZE', '-s', 'EXPORT_NAME="createModule"', '--extern-pre-js', browser_reporting_js_path], reporting=Reporting.NONE)
     create_test_file('a.html', '''
       <script src="a.out.js"></script>
       <script>
@@ -5019,6 +5019,9 @@ def test_manual_pthread_proxy_hammer(self, args):
                # *meant* to notice something random, a race condition.
                extra_tries=0)
 
+  def test_assert_failure(self):
+    self.btest(path_from_root('tests', 'browser', 'test_assert_failure.c'), 'abort:Assertion failed: false && "this is a test"')
+
 
 EMRUN = path_from_root('emrun')
 
